package jumbo.xml;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;

/** a very small class to find and check and non-XML characters in a
document
@author P.Murray-Rust, 1998
*/

public class CheckValidChar {
    public static void main(String[] args) {
        if (args.length == 0) {
            System.out.println("Usage: java  jumbo.xml.CheckValidChar filename [lineNumber]");
            System.exit(1);
        }
        try {
            BufferedReader br = new BufferedReader(new InputStreamReader
                (new URL(Util.makeAbsoluteURL(args[0])).openStream()));
            int lineCount = 0;
            int targetLine = -1;
            if (args.length == 2) {
                targetLine = Integer.parseInt(args[1]);
            }
            while (true) {
                String line = br.readLine();
                if (line == null) break;
                lineCount++;
                int l = line.length();
                for (int i = 0; i < l; i++) {
                    char ch = line.charAt(i);
                    int ich = (int) ch;
                    if ((ich >= 32) && (ich <= 127)) {
                    } else {
                        System.out.println(""+lineCount+":"+i+" ("+ch+") in: "+line);
                    }
                }
                if (lineCount == targetLine) System.out.println(line);
            }
        } catch (Exception e) {
            System.out.println(e);
        }
    }
}
